//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_packet_statistic.cpp
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2009-2020
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#ifdef __linux__
	// LINUX ---------------
	// LINUX ---------------
	// LINUX ---------------
	#include "../usb-ftdi/ftd2xx.h"
	
	#include "library/delib/delib.h"
	#include "library/vc/deditec_tcp_io.h"	// muss vor die "delib_intern.h", weil hier TCP_IO drin ist
	#include "library/delib/delib_intern.h"
	
	#include "delib_packet_statistic.h"
	#include "delib_hdlmgr.h"
	#include "library/vc/deditec_timer.h"
#else
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
	#include <windows.h>
#endif
	#include "proj_config.h"
	

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void PacketStatisticStart(unsigned long handle32)
{
	DAPI_HANDLE *DapiHandle;
	ULONGLONG handle_ull;

	if(DapiInternHandlePointerGet(handle32, &handle_ull) == RETURN_OK)
	{
		DapiHandle = (DAPI_HANDLE*) DAPI_PTR_SIZE handle_ull;
	}
	else
	{
		return;
	}
	
	dt2_timerus_start();
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void PacketStatisticEnd(unsigned long handle32, unsigned long command_type, unsigned long delib_error_code)
{
	DAPI_HANDLE *DapiHandle;
	unsigned long time_elapsed;
	
	ULONGLONG handle_ull;

	if(DapiInternHandlePointerGet(handle32, &handle_ull) == RETURN_OK)
	{
		DapiHandle = (DAPI_HANDLE*) DAPI_PTR_SIZE handle_ull;
	}
	else
	{
		return;
	}
	
	time_elapsed = dt2_timerus_diff();
	
	switch (command_type)
	{
		case PKT_STAT_CMD_TYPE_NORMAL:
			if(( DapiHandle->packet_statistic_transmit_normal_time_us_min == 0) &&
				(DapiHandle->packet_statistic_transmit_normal_time_us_max == 0))
			{
				DapiHandle->packet_statistic_transmit_normal_time_us_min = time_elapsed;
				DapiHandle->packet_statistic_transmit_normal_time_us_max = time_elapsed;
			}
			if (time_elapsed < DapiHandle->packet_statistic_transmit_normal_time_us_min)
			{
				DapiHandle->packet_statistic_transmit_normal_time_us_min = time_elapsed;
			}
			if (time_elapsed > DapiHandle->packet_statistic_transmit_normal_time_us_max)
			{
				DapiHandle->packet_statistic_transmit_normal_time_us_max = time_elapsed;
			}
			break;
			
		case PKT_STAT_CMD_TYPE_MULTIPLE:
			if(( DapiHandle->packet_statistic_transmit_multiple_time_us_min == 0) &&
				(DapiHandle->packet_statistic_transmit_multiple_time_us_max == 0))
			{
				DapiHandle->packet_statistic_transmit_multiple_time_us_min = time_elapsed;
				DapiHandle->packet_statistic_transmit_multiple_time_us_max = time_elapsed;
			}
			if (time_elapsed < DapiHandle->packet_statistic_transmit_multiple_time_us_min)
			{
				DapiHandle->packet_statistic_transmit_multiple_time_us_min = time_elapsed;
			}
			if (time_elapsed > DapiHandle->packet_statistic_transmit_multiple_time_us_max)
			{
				DapiHandle->packet_statistic_transmit_multiple_time_us_max = time_elapsed;
			}		
			break;
	}
	
		 if (delib_error_code == DAPI_ERR_NONE) 							{DapiHandle->packet_statistic_cnt_DELIB_ERR_NONE++;}
	else if ((delib_error_code & 0xff00) == DAPI_ERR_GEN_CLASS)	{DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_GEN++;}
	else if ((delib_error_code & 0xff00) == DAPI_ERR_COM_CLASS)	{DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_COM++;}
	else if ((delib_error_code & 0xff00) == DAPI_ERR_DEV_CLASS)	
	{
			 if ((delib_error_code & 0x00ff) == 0x00)						{DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_PKT++;}
		else if ((delib_error_code & 0x00ff) == 0x30)						{DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_IO++;}
		else																{DapiHandle->packet_statistic_cnt_DELIB_ERR_CLASS_DEV_OTHER++;}
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
