//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_intern.h
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2009-2020
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// --------------------------------------------------------

#define HandlePointerMAX			1024
#define HandlePointerSTART			0x127482

// --------------------------------------------------------
#define MAX_NO_OF_MODULES_NR		256
#define MAX_NO_OF_MODULES_MASK		0xff

#define DAPI_OPEN_MODULE_OPTION_DISABLE_ENCRYPTION		0x4000
#define DAPI_OPEN_MODULE_OPTION_DISABLE_CHK_MODULE_CFG	0x8000
#define DAPI_OPEN_MODULE_MODULE_NR_MASK					0x3FFF

// --------------------------------------------------------

#define RETURN_HANDLE_NULL			0

#define delib_id					0x12345678

#define DapiModuleID_Device			1
#define DapiModuleID_DeviceProg		0

// --------------------------------------------------------

#ifndef __linux__
	#define USE_FTDI_DUAL 1
	#define USE_FTDI 1
	#define USE_SER 1
	#define USE_ETH 1
	#define USE_FTDI_SER 1
#endif

// --------------------------------------------------------
// --------------------------------------------------------

#ifdef __linux__
	#ifdef USE_ETH
		#define FT_HANDLE unsigned long
	#endif
#endif

typedef struct xxDAPI_HANDLE
{
	ULONG id;
	FT_HANDLE ftHandle;
	TCP_IO* tcp_params;
	ULONG TCPHandle_tx;
	ULONG moduleID;
	ULONG moduleNr;
	ULONG SubDevice;
	ULONG jobID;
	ULONG BusType;
	ULONG ComPort;
	ULONG RS485_ModuleNr;
	UCHAR ProgramName[12];
	UCHAR CANopenStickSondermodus;

	ULONGLONG addr_dapi_module_params;
	ULONG lasterror;
	
	BOOL ftdi_use_protocol_new;
	ULONG retry;					// usb, ser
	ULONG timeout;					// eth
	ULONG encryption_type;			// eth
	UCHAR encryption_password[32];	// eth
	UCHAR ip_addr[32];				// eth

	BOOL is_Adr_32_mode;

	ULONG packet_statistic_cnt_DELIB_ERR_NONE;
	ULONG packet_statistic_cnt_DELIB_ERR_CLASS_GEN;
	ULONG packet_statistic_cnt_DELIB_ERR_CLASS_COM;
	ULONG packet_statistic_cnt_DELIB_ERR_CLASS_DEV_PKT;
	ULONG packet_statistic_cnt_DELIB_ERR_CLASS_DEV_IO;
	ULONG packet_statistic_cnt_DELIB_ERR_CLASS_DEV_OTHER;

	ULONG packet_statistic_transmit_normal_time_us_min;
	ULONG packet_statistic_transmit_normal_time_us_max;
	ULONG packet_statistic_transmit_normal_count_retry;
	ULONG packet_statistic_transmit_normal_count_recon;
	
	ULONG packet_statistic_transmit_multiple_time_us_min;
	ULONG packet_statistic_transmit_multiple_time_us_max;
	ULONG packet_statistic_transmit_multiple_count_retry;
	ULONG packet_statistic_transmit_multiple_count_recon;
	
} DAPI_HANDLE;

// --------------------------------------------------------
typedef struct xxDAPI_MODULE_PARAMS
{
	char fw_version[4];
	ULONG hw_interface1;
	ULONG sw_feature1;
	ULONG tcp_feature1;
	ULONG anz_di;
	ULONG anz_di_counter;
	ULONG anz_di_ff;
	ULONG anz_do;
	ULONG anz_ai;
	ULONG anz_ao;
	ULONG anz_stepper;
	ULONG anz_temp;
	ULONG anz_counterin48;
	ULONG anz_counterout32;
	ULONG anz_output_pwm;
	ULONG anz_dx;
	ULONG sw_class;
	ULONG hw_group;
	ULONG moduleID;
} DAPI_MODULE_PARAMS;

// --------------------------------------------------------

#define bus_FTDI_DUAL					1
#define bus_SeriellCOM					2
#define bus_SeriellFTDI					3
#define bus_ETH							4
#define bus_FTDI_SINGLE_SER				5
#define bus_FTDI_SINGLE_PAR				6
#define bus_ETH_INTERN					7

#define DAPI_INTERFACE_UNDEFINED		0
#define DAPI_INTERFACE_CAN				1
#define DAPI_INTERFACE_USB				2
#define DAPI_INTERFACE_ETH				3
#define DAPI_INTERFACE_SER				4

// --------------------------------------------------------

#ifdef __linux__
	#define DAPI_SPECIAL_CMD_MODULE_CONFIG					0xf0000001
	#define DAPI_SPECIAL_MODULECFG_MODULE_ID_SET			1
#endif
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiADGetXXX(ULONG handle, ULONG ch);
DAPI_FUNCTION_PRE64 float DAPI_FUNCTION_PRE DapiADGetValueModeUnitXXX(ULONG handle, ULONG ch, ULONG *mode, ULONG *unit);

DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiDASetXXX(ULONG handle, ULONG ch, ULONG data);
DAPI_FUNCTION_PRE64 float DAPI_FUNCTION_PRE DapiDAGetValueModeUnitXXX(ULONG handle, ULONG ch, ULONG *mode, ULONG *unit);
DAPI_FUNCTION_PRE64 void  DAPI_FUNCTION_PRE DapiDASetModeXXX(ULONG handle, ULONG ch, ULONG mode);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiDAGetModeXXX(ULONG handle, ULONG ch);
// --------------------------------------------------------
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiSpecialCommandXXX(ULONG handle, ULONG cmd, ULONG par1, ULONG par2, ULONG par3);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiSpecialCommandExtXXX(ULONG handle, ULONG cmd, ULONG par1, ULONG par2, ULONG par3, ULONG *par4, ULONG *par5, ULONG *par6, UCHAR *buff1, ULONG buff1_size, UCHAR *buff2, ULONG buff2_size, UCHAR *buff3, ULONG buff3_size, ULONG *buff3_length);
// --------------------------------------------------------
DAPI_FUNCTION_PRE64 ULONG     DAPI_FUNCTION_PRE DapiDOReadback32XXX(ULONG handle, ULONG ch);
// --------------------------------------------------------
DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiDOSetBit32XXX(ULONG handle, ULONG ch, ULONG data);
DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiDOClrBit32XXX(ULONG handle, ULONG ch, ULONG data);
// --------------------------------------------------------
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleXXX(ULONG moduleID, ULONG nr);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleExXXX(ULONG moduleID, ULONG nr, unsigned char* exbuffer, ULONG open_options);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiCloseModuleXXX(ULONG handle);

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiOpenDebugChannelXXX(ULONG moduleID, ULONG moduleNr);
// --------------------------------------------------------
// Register Access
DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiWriteByteXXX(ULONG handle, ULONG adress, ULONG value);
DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiWriteWordXXX(ULONG handle, ULONG adress, ULONG value);
DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiWriteLongXXX(ULONG handle, ULONG adress, ULONG value);
DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiWriteLongLongXXX(ULONG handle, ULONG adress, ULONGLONG value);

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiReadByteXXX(ULONG handle, ULONG adress);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiReadWordXXX(ULONG handle, ULONG adress);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiReadLongXXX(ULONG handle, ULONG adress);
DAPI_FUNCTION_PRE64 ULONGLONG DAPI_FUNCTION_PRE DapiReadLongLongXXX(ULONG handle, ULONG adress);
// --------------------------------------------------------
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiReadMultipleBytesXXX(ULONG handle, ULONG adress, ULONG adress_depth, ULONG increments, UCHAR * buff, ULONG buff_len);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiWriteMultipleBytesXXX(ULONG handle, ULONG adress, ULONG adress_depth, ULONG increments, UCHAR * buff, ULONG buff_len);
// --------------------------------------------------------
// CAN Commands
DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE  DapiCANSendPacketXXX(unsigned long handle32, DAPI_CAN_MESSAGE_STRUCT *can_msg);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiCANGetPacketXXX(unsigned long handle32, ULONG message_box_nr, DAPI_CAN_MESSAGE_STRUCT *can_msg);
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE  DapiCANCommandXXX(ULONG handle32, ULONG cmd, ULONG par1, ULONG par2, ULONG par3);
// --------------------------------------------------------

