	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	
	#include <string.h>
	//#include "../delib/library/delib/delib_intern.h"
	
	#define bus_FTDI_DUAL					1
	#define bus_SeriellCOM					2
	#define bus_SeriellFTDI					3
	#define bus_ETH							4
	#define bus_FTDI_SINGLE_SER				5
	#define bus_FTDI_SINGLE_PAR				6
	#define bus_ETH_INTERN					7

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	FT_STATUS WINAPI FT_Write(FT_HANDLE ftHandle, LPVOID lpBuffer, DWORD nBufferSize, LPDWORD lpBytesWritten)
	{
		UCHAR* buff;
		char msg[200];

		buff = lpBuffer;
		ULONG i;
	    int f;
	
		f = ftdi_write_data((struct ftdi_context *) ftHandle, buff, nBufferSize);
	    if (f < 0)
	    {
			sprintf(msg,"Error Writing %d bytes ", (int) nBufferSize);
			debug_print(msg);
	//		sprintf(msg,write ftdic = 0x%x\n", ftHandle);
	//		debug_print(msg);
			for(i=0;i!=nBufferSize;++i) {
				sprintf(msg,"%x ", (char) *(buff + i));
				debug_print(msg);
			}
	        sprintf(msg,"write failed error %d (%s)\n",f, ftdi_get_error_string((struct ftdi_context *) ftHandle));
			debug_print(msg);
			*lpBytesWritten = 0;
			//exit -1;
			return -1;
	    }

	//printf("WRITTEN %d bytes\n", f);

		*lpBytesWritten = f;
		return FT_OK;
	}

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	FTD2XX_API FT_STATUS WINAPI FT_Read(FT_HANDLE ftHandle, LPVOID lpBuffer, DWORD nBufferSize, LPDWORD lpBytesReturned)
	{
		char msg[200];
		UCHAR* buff;
		int f;

		buff = lpBuffer;

		f=ftdi_read_data((struct ftdi_context *) ftHandle, buff, nBufferSize);
	    if (f < 0)
	    {
	        sprintf(msg,"read failed error %d (%s)\n",f, ftdi_get_error_string((struct ftdi_context *) ftHandle));
			debug_print(msg);
			*lpBytesReturned = 0;
			exit;
	    }

		*lpBytesReturned = f;
		return FT_OK;
	}

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	FTD2XX_API FT_STATUS WINAPI FT_GetQueueStatus(FT_HANDLE ftHandle, DWORD *dwRxBytes)
	{
	}

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	FTD2XX_API FT_STATUS WINAPI FT_Open(int deviceNumber, FT_HANDLE *pHandle)
	{
	}

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	FTD2XX_API FT_STATUS WINAPI FT_Close(FT_HANDLE ftHandle)
	{
	    ftdi_usb_close((struct ftdi_context *) ftHandle);
		ftdi_free((struct ftdi_context *) ftHandle);

		return FT_OK;
	}

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	FTD2XX_API FT_STATUS WINAPI FT_OpenEx(PVOID pArg1, DWORD Flags, FT_HANDLE *pHandle, DWORD BusType)
	{
		char msg[200];
		unsigned long len;
		unsigned char *pSN;
		int f;
		struct ftdi_context *ftdic;

		pSN = (char*) pArg1;

		ftdic = ftdi_new();
		if (ftdic == NULL)
		{
	        sprintf(msg,"ftdi_init failed\n");
			debug_print(msg);
	        return -1;			
		}

		if(Flags == FT_OPEN_BY_SERIAL_NUMBER)
		{
			switch (BusType)
			{					
				case bus_FTDI_DUAL:
					debug_print("try to open FT2232D/C\n");
					ftdi_set_interface(ftdic, INTERFACE_B);
					f = ftdi_usb_open_desc_index(ftdic, 0x0403, 0x6010, 0, pArg1, 0);	// FT2232 (DUAL)
					break;

				case bus_FTDI_SINGLE_SER:
				case bus_SeriellFTDI:
					debug_print("try to open FT232R\n");
					f = ftdi_usb_open_desc_index(ftdic, 0x0403, 0x6001, 0, pArg1, 0);	// FT232R  (Single)
					if (f < 0 && f != -5)
					{
						// FT231X
						debug_print("try to open FT231X\n");
						f = ftdi_usb_open_desc_index(ftdic, 0x0403, 0x6015, 0, pArg1, 0);	// FT231X  (Single)
					}
					break;
					
				case bus_FTDI_SINGLE_PAR:
					debug_print("try to open FT232H\n");
					f = ftdi_usb_open_desc_index(ftdic, 0x0403, 0x6014, 0, pArg1, 0);	// FT232H  (Single)
					break;
					
				default:
					printf("Unknown BusType\n");
					ftdi_free(ftdic);
					return -1;
					
			}
	
			if (f < 0 && f != -5)
			{
				sprintf(msg,"unable to open ftdi device: %d (%s)\n", (unsigned int) f, (char*) ftdi_get_error_string(ftdic));
				debug_print(msg);
				ftdi_free(ftdic);
				return -1;
		    }
		}

		*pHandle = (FT_HANDLE) ftdic;

		return FT_OK;
	}

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	FTD2XX_API
	FT_STATUS WINAPI FT_Purge(
	    FT_HANDLE ftHandle,
		ULONG Mask
		)
	{
	}
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
