#!/bin/bash

bin_name=ethernet_sample
if [ `getconf LONG_BIT` = "64" ]
then
	# 64 bit
    lib_dir="../../delib-sources/delib/lib/build_x64"
else
	# 32 bit
    lib_dir="../../delib-sources/delib/lib/build_x86"
fi
preprocessor_defines="-D ENABLE_TCP_ENCRYPTION -D USE_ETH"

list_of_files="
source/ethernet_sample.c

../../delib-sources/delib/library/vc/deditec_timer.c
../../delib-sources/delib/library/embedded/deditec_debug_comfort.c

../../delib-sources/delib/delib_hdlmgr.c
../../delib-sources/delib/delib_packet_statistic.c
../../delib-sources/delib/delib_Dapi_di_do_ad_da_befehle.c
../../delib-sources/delib/delib_set_get_error.c
../../delib-sources/delib/delib_Dapi_register_commands.c
../../delib-sources/delib/delib_open_close.c
../../delib-sources/delib/delib_io_tcp.c

../../delib-sources/delib/library/vc/deditec_tcp_io.c
../../delib-sources/delib/library/vc/deditec_buff_utils.c
../../delib-sources/delib/library/vc/deditec_string_utils.c
../../delib-sources/delib/library/vc/deditec_convert_functions.c
 -g"
 
echo now compiling $bin_name
gcc $preprocessor_defines -L$lib_dir -Wl,-rpath=$lib_dir -o $bin_name $list_of_files -lDelibTcp

if [ $? != "0" ]
   then echo
        echo "error(s) found while compiling"
        exit 100
   else echo
        echo "compiling successfull"
fi
